package com.example.nan_scan;

import android.app.Activity;
import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;

public class NanScanPlugin2 implements FlutterPlugin, ActivityAware {
    private static final String VIEW_TYPE = "com.scan.widget";
    private FlutterPluginBinding pluginBinding;
    private Activity activity;

    @Override
    public void onAttachedToEngine(@NonNull @org.jetbrains.annotations.NotNull FlutterPlugin.FlutterPluginBinding binding) {
        this.pluginBinding = binding;

    }

    private void configChannel(ActivityPluginBinding binding) {
        activity = binding.getActivity();
        pluginBinding.getPlatformViewRegistry()
                .registerViewFactory(VIEW_TYPE, new NanScanFactory(
                        pluginBinding.getBinaryMessenger(),
                        pluginBinding.getApplicationContext(),
                        activity,
                        binding
                ));
    }

    @Override
    public void onDetachedFromEngine(@NonNull @org.jetbrains.annotations.NotNull FlutterPlugin.FlutterPluginBinding binding) {
        pluginBinding = null;
    }

    @Override
    public void onAttachedToActivity(@NonNull @org.jetbrains.annotations.NotNull ActivityPluginBinding binding) {
        configChannel(binding);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {
//        this.onDetachedFromActivity();
    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull @org.jetbrains.annotations.NotNull ActivityPluginBinding binding) {
//        onAttachedToActivity(binding);
        configChannel(binding);
    }

    @Override
    public void onDetachedFromActivity() {
        activity = null;
    }
}
