
import 'dart:io';
import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:nan_scan/nan_scan_channel.dart';
import 'package:nan_scan/nan_scan_page.dart';

const VIEW_TYPE = 'com.scan.widget';
class NanScanWidget extends StatefulWidget{

  final Function onResult;
  final Widget child;
  NanScanWidget({
    Key key,
    this.onResult,
    this.child,
  }):super(key: key);

  @override
  _NanScanWidgetState createState() => _NanScanWidgetState();


}
class _NanScanWidgetState extends State<NanScanWidget>{
  MethodChannel _channel;


  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
    NanScanMethod.disposeScan();
  }


  @override
  Widget build(BuildContext context) {

    return Stack(
      children: [
        Platform.isIOS?UiKitView(
          viewType: VIEW_TYPE,
          // onPlatformViewCreated: onPlatformViewCreated,
          // gestureRecognizers: gestureRecognizers,
          creationParams: creationParams,
          creationParamsCodec: const StandardMessageCodec(),
          onPlatformViewCreated: (id){
            _onPlatformViewCreated(id);
          },
        ):AndroidView(
          viewType: VIEW_TYPE,
          creationParams: creationParams,
          creationParamsCodec: const StandardMessageCodec(),
          onPlatformViewCreated: (id){
            _onPlatformViewCreated(id);
          },
        ),
        Offstage(
          offstage: widget.child == null,
          child: widget.child,
        )
      ],
    );
  }

  final Map<String, dynamic> creationParams = <String, dynamic>{
      'params': "拓展",
  };

  void _onPlatformViewCreated(int id) {
    _channel = MethodChannel('nan_scan_method_$id');
    NanScanMethod.init(_channel);
    _channel?.setMethodCallHandler((MethodCall call) async {
      if (call.method == 'onCaptured') {
        if (widget.onResult != null)
          widget.onResult(call.arguments.toString());
      }
    });
  }
}